;================궨========================
sda					==	p6.7;p6.0;	;SDAҪ
scl					==	p5.1;p6.7;  

port_scl			==	p5;
port_sda			==	p6 

data_set_sclOut		==	0B11111101		;sclΪ
data_set_sdaOut		==	0B01111111		;sdaΪ
data_set_SdaIn		==	0B10000000		;sdaΪ	

READ24C02           ==	0xa1
WRITE24C02          == 	0xa0
;----sad 24c02---------------
set_sda   macro
          bts        p6,7 
endm
;============================
clr_sda   macro
          btc        p6,7 
endm
;----sclk 24c02--------------
set_scl   macro
          bts       p5,1;p6,7; 
endm
;============================
clr_scl   macro
          btc        p5,1;p6,7;
endm
;---SDAΪ---------
set_sdaOut	macro
	ir		port_sda
	and		a,@data_set_sdaOut		;sdaΪ 
	iw		port_sda  
endm
;---SDAΪ---------
set_SdaIn	macro
	ir		port_sda
	or		a,@data_set_SdaIn	 
	iw		port_sda
endm
;---SclΪ---------
set_sclOut	macro    	
	ir		port_scl
	and		a,@data_set_sclOut		;sclΪ 
  	iw		port_scl
endm
;--------------Ĵ-----------------------
bit_24C02Err			==	0x10.0

read_24c02_temp1		==	0X2a 
i2c_add					==	0x2b
i2c_dat					==	0x2c

i2c_buff              	==	0x2d 	;д
i2c_cnt              	==  0x2e   	;ƶ  
;=============================
;=======letter delay==========
;=============================  
nop_8:
		jmp		$+1
		jmp  	$+1
nop_6:
		jmp 	$+1
		cwdt
nop_2:
		jmp		$+1
		jmp 	$+1
		ret 
;-------------------------------
;function   :   start_24c02
;in         :   none
;out        :   none
;description:   start iic bus
; I2Cʼλ 
;-------------------------------
i2c_start: 
		set_sdaOut		;sdaΪ  
		set_sclOut		;sclΪ  
     	    
		set_sda
		set_scl
		call 	nop_8	;8.19us >4.7us
		clr_sda
		call	nop_8	;>4us
		clr_scl
		call 	nop_6	;>4.7us
		ret  
;-------------------------------
;function   :   stop_24c02
;in         :   none
;out        :   none
;description:   stop iic bus
; I2C߽λ 
;-------------------------------
i2c_stop:
		set_sdaOut		;sdaΪ  
		set_sclOut		;sclΪ  
     
		clr_scl
		clr_sda
		call 	nop_8
		set_scl
		call 	nop_8               ;>4us
		set_sda
		call 	nop_8               ;>4.7us 
		ret  
;-------------------------------
;function   :   i2c_ack
;in         :   none
;out        :   none
;description:   Ӧź
;-------------------------------
i2c_ack:
		btc  	bit_24C02Err 
           
		set_SdaIn	  
     	  
		set_scl
		call 	nop_8
		jbtc	sda
		bts		bit_24C02Err 
          	 
		set_sdaOut		;sdaΪ  
		set_sclOut		;sclΪ  
          
		clr_scl
		ret 
;===============================
;===============================
sendAck:
		clr_sda
		call 	nop_8
		set_scl
		call	nop_8
		clr_scl
		call	nop_6
		ret 
;-------------------------------
;function   :   i2c_write_8bit
;in         :   i2c_buff
;out        :   none
;description:   write 8 bit to 24c02
;-------------------------------
i2c_write_8bit:
		mov  	i2c_buff,a
		mov  	a,@8
		mov 	i2c_cnt,a 
write_8bit:  
		clr_scl
		call	nop_2
		lcr 	i2c_buff 
		jbts	c
		jmp  	send_zero
		set_sda
		jmp 	w_deal
send_zero:
		clr_sda
w_deal:
		call 	nop_8
		set_scl
		call  	nop_8
          
		dj	 	i2c_cnt 
		jmp  	write_8bit
          
		clr_scl
		call	nop_2
		ret 
;-------------------------------
;function   :   i2c_read_8bit
;in         :   none
;out        :   r_from_24c02
;description:   read 8 bit from 24c02
;-------------------------------
i2c_read_8bit: 
		set_SdaIn		;sdaΪ	  

		mov 	a,@8
		mov 	i2c_cnt,a
		clr		i2c_buff 
read_8bit:
		clr_scl
		call 	nop_8
		call 	nop_8
		;call	delay15us
		set_scl
		call 	nop_8
          	
		btc  	c
		jbtc 	sda
		bts  	c 
		lcr 	i2c_buff
          	
		dj		i2c_cnt
		jmp 	read_8bit
           
		set_sdaOut		;sdaΪ  
		set_sclOut		;sclΪ  
          
		clr_scl
		call 	nop_6 
		ret 
;---------------------------------
;function   :   i2c_read_byte
;in         :   none
;out        :   none
;description:   24C02ж8λ
;---------------------------------
i2c_read_byte:
		di   
		call	i2c_start              	;START
		mov 	a,@WRITE24C02        	;SLAVE ADDRESS
		call	i2c_write_8bit
		call 	i2c_ack
		jbtc	bit_24C02Err
		jmp 	i2c_read_byte
read_address:          
		mov  	a,i2c_add	;ʼַ @0x50 			;ѧϰĴַ  BYTE ADDRESS     
		call 	i2c_write_8bit
		call 	i2c_ack
		jbtc 	bit_24C02Err 
		jmp  	i2c_read_byte
set_read:           
		call 	i2c_start              	;START 
		mov 	a,@READ24C02
		call	i2c_write_8bit          		;SLAVE ADDRESS
		call	i2c_ack
		jbtc 	bit_24C02Err
		jmp 	i2c_read_byte  
;------------һ----------------------          	
read_data:
		call 	i2c_read_8bit              ;STOP  
		call  	i2c_stop   
		mov  	a,i2c_buff   
		ret 
;---------------------------------
;function   :   i2c_write_byte
;in         :   none
;out        :   none
;description:   д1λ
;---------------------------------
i2c_write_byte: 
		di  
		call  	i2c_start        	;START
		mov  	a,@WRITE24C02
		call 	i2c_write_8bit           ;SLAVE ADDRESS
		call 	i2c_ack
		jbtc	bit_24C02Err
		jmp   	i2c_write_byte
          
		mov		a,i2c_add         	;
		call   	i2c_write_8bit           	;BYTE ADDRESS
		call   	i2c_ack
		jbtc	bit_24C02Err
		jmp    	i2c_write_byte           	;.
          
		mov    	a,i2c_dat       	;д
		call   	i2c_write_8bit           	;DATA N
		call   	i2c_ack
		jbtc	bit_24C02Err
		jmp	 	i2c_write_byte
		call   	i2c_stop
		ret 
;----------------24c02д------------------
file_24c02Test: 
		mov		a,@0x20 
		mov  	i2c_add,a 
		mov		a,@0x12
		mov		i2c_dat,a
		call	i2c_write_byte 
		call	delay_10ms
;--------------ߵַ--------------------
		mov		a,@0x20
		mov		i2c_add,a  
;--------------3λߵַ ------------------   
		call 	i2c_read_byte 				 
		mov		read_24c02_temp1,a  
		ret 
;============ʱ100ms============
delay_100ms:
    	mov		a,@10       ;Ĵ˴ɸıʱʱ
    	mov		delay_a,a
    	jmp		cc
;===========ʱ10ms============
delay_10ms:
    	mov		a,@1       ;Ĵ˴ɸıʱʱ
    	mov		delay_a,a
    	jmp		cc
cc:
    	mov		a,@33
    	mov		delay_b,a
bb:
    	mov		a,@196
		mov		delay_c,a
aa:
		dj 		delay_c
		jmp		aa     
		dj	 	delay_b
		jmp 	bb
		dj 		delay_a
		jmp		cc
	    ret 